[TinyPortal](https://www.tinyportal.net/) - Portal Mod for SMF
==================================================
![](https://www.tinyportal.net/Themes/alphacentauri203/images/theme/logo_light.png)

[![Latest Version](https://img.shields.io/github/release/TinyPortal/TinyPortal.svg)](https://github.com/TinyPortal/TinyPortal/releases)
[![Total Downloads](https://img.shields.io/github/downloads/TinyPortal/TinyPortal/total.svg)](https://github.com/TinyPortal/TinyPortal/releases)
[![GitHub issues](https://img.shields.io/github/issues/TinyPortal/TinyPortal.svg)](https://github.com/TinyPortal/TinyPortal/issues)

## What is TinyPortal?

TinyPortal is a mod for SMF that adds a powerful and mature CMS to your SMF Forum in minutes, with native integration, without having to worry about bridging, database, and appearance. Your SMF and TP will be a homogenous ensemble from installation. It's up to you and your creativity to use TP's features to customize your site and organize its content.

## Features included in TinyPortal:

- **Article System:** The article system gives you a CMS system tightly integrated with your forum. Write articles in php, html or bbcode, and choose what member-groups can access them, who can contribute, and how they are approved.

- **Blocks and Panels:** Blocks is a term for the rectangles of information you can use throughout the portal. For the sake of simplicity the page has been divided into the "panels", which when combined can mimic many common page layouts. Blocks can contain regular html, BBC, php code or special written functions that collect specific types of information. You can show them according to which permissions the visitor has, and even show them just in certain sections. 
TinyPortal comes with a number of standard block types, such as: Recent Posts, Theme switcher, Search, Calendar, Poll, RSS feeds, Menu, User Profile block and News.

- **Menu Manager:** The menu manager lets you add single level Buttons / Tabs to the SMF menu, but also create menu's within a portal block available to specific membergroups. You can create and organize various types of menu items: links to articles, categories, or even just a custom link. You can choose to have the link open in the current window or a new window.

- **Downloads Manager**: A built-in module for TP that lets you offer files for your members to browse and download. Its works by having the downloadable files placed in categories, letting you restrict member groups access level per each category.

- **ShoutBox:** An integrated message box in which you can leave messages for others to see and thus maintain a simple "chat" on the site. Combined with permissions you will have much freedom in who can participate as well.

## Questions?
For more detailed information about the features of TinyPortal and how to use them, check out the [TinyPortal documentation](https://www.tinyportal.net/docs). If you cannot find what you are looking for in the documentation, please feel free to ask on the [TinyPortal Support forum](https://www.tinyportal.net)

## Changelog
Please click on the appropriate release to see the [Changelog](https://github.com/Tinyportal/TinyPortal/tags)

## What you need to install TinyPortal
1. In order to install TinyPortal, you need to have a working version of Simple Machines Forum. 
SMF version must be SMF2.x.
2. Zip files are provided for install both on the 
[Simple Machines Site](https://custom.simplemachines.org/index.php?mod=97) and the [TinyPortal Site](https://www.tinyportal.net/index.php?action=tportal;sa=download;dl=cat61) (the archive with old version packages is available in the download section).

Note: You must uninstall any previous version of TinyPortal before you can install TinyPortal for SMF2.x. Make a backup of all your SMF and TP files before you uninstall.

**NOTICE!: Due to a bug in SMF 2.1.3 upgrading TinyPortal may result in one of these error messages: "All parts of a PRIMARY KEY must be NOT NULL; if you need NULL in a key, use UNIQUE instead" or "Database error: Invalid default value for 'item_type'".** 
**If you encounter these errors while on SMF 2.1.3 you will need to install the [correction MOD that can be downloaded from the TinyPortal.net support site](https://www.tinyportal.net/index.php?action=tportal;sa=download;dl=item177). After applying this MOD you will be able to re-install TinyPortal on SMF 2.1.3. Please note that the correction MOD should be uninstalled prior to patching SMF to version 2.1.4.**

## License Information:
The contents of this file are subject to the Mozilla Public License Version 2.0 (the "License");
you may not use this package except in compliance with the License. You may obtain a copy of the License at
https://www.mozilla.org/en-US/MPL/2.0/
